#!/usr/bin/env python
# -*- coding: utf-8 -*-
#--------------------------------------------------------------------
# Filname: @FileName@
# Author: @Author@
# Created: @Date@
# ID: $Id: misc.py 13 2008-11-29 18:31:31Z alex $
# URL: $URL: file:///myfiles/svn_/XPyLIB/trunc/XPyLIB/misc.py $
# Copyright: @Copyright@
# License: BSD
#--------------------------------------------------------------------


"""
Miscilaneous functions.
"""

def getConfigParserOptions(sec, cp, raw=0):
    """
    Return readed options and it's values in dictionary.
    
    If such section is absent then return empty dict.
    
    @param sec: Section name.
    @type sec: str
    @param cp: Config parser instance.
    @type cp: ConfigParser
    @param raw: Raw mode for get in ConfigParser.
    @type raw: int = {0}
    @return: Dictionary with options and values.
    @rtype: dict
    """
    r = {}
    if cp.has_section(sec):
        r = dict( (n, cp.get(sec,n,raw)) for n in cp.options(sec) )
    return r

def resolveName(name):
    """
    Resolve a dotted name to a global object.
    
    @param name: Dotted name for resolve.
    @type name: str
    @return: resolved and if need imported object.
    @rtype: object
    """
    name = name.split('.')
    used = name.pop(0)
    found = __import__(used)
    for n in name:
        used = used + '.' + n
        try:
            found = getattr(found, n)
        except AttributeError:
            __import__(used)
            found = getattr(found, n)
    return found

