#!/usr/bin/env python
# -*- coding: utf-8 -*-
#--------------------------------------------------------------------
# Author: Mazhugin Aleksey
# Created: 2007/09/24
# ID: $Id: __init__.py 5 2007-10-31 18:29:04Z alex $
# URL: $URL: file:///H:/svn_/XPyLIB/trunc/XPyTools/codetpl/__init__.py $
# Copyright: Copyright (c) 2007, Mazhugin Aleksey
# License: BSD
#--------------------------------------------------------------------
# Package initialisation

"""
Package for enhance writing of source code.

B{List of package}:
===================

    - codetpl - Code templates.
    - guiCodeTpl - Gui interface for Code Templates.
    - [boa_pluggins] - Boa constructor plug-ins.
        - CodeTemplates.plug-in.py - add codetpl to Boa constructor.
            Plug-in was named same name as original
            becouse then assign other name then plug-in do not load or
            no initialize or other bugs is occurs (on my system ... or may be
            other systems too, i don't know yet).
        - CodeTemplates.plug-in.py_v0.6.1.original - The original plug-in that was
            contributed with Boa constructor 0.6.1 beta. 

codetpl manual.
===============

    Provide functionality for code templates uses.
    
    All templates saved into directory "./templates".
    You may save you templates in other dirictory that you like and
    add they paths into configuration file.
    
    Conventions for templates name: I{typ_name.py}, where
        - I{typ} - template type,
        - I{name} - template name.
    By default defined next types:
        - kwd_*.py - keywords (used inside templates).
        - tpl_*.py - templates for insert "Code templates".
        - act_*.py - template actions "Template actions".
        - new_*.py - templates for "New file".
        - wzd_*.py - templates for "Wizards".
        - wtp_*.py - templates, more powerfull then I{tpl}.
        
    Function's definition for template  must like: "C{def ???_*(fields):}",
    where "I{fields}" - dict (for user enter values for fields),
    "I{???}" - type of template, "I{*}" - name of template.
    
    Function's definition for keywords  must like: "C{def kwd_*():}",
    where "I{*}" - name of keyword.
    
    If function preffix is other or absent then this function is not
    interpreted as template or keyword.
    
    
    Functions must return string or other objet which may be converted
    to string by operator C{str()}. From returned string will be removed first
    and last newline characters. vIf returned string is empty then no
    result applying to source code.
    
    Difference between templates and keywords is that keywords function
    string paste into code as is, other templates interpreted
    with using next rules.
    
    Interpreter rules.
    ------------------
            
        In string you may use follow templates:
            
            - @Name@ - Search and replace "Name" from "fields" dict if not find
                then search in keywords.
            - You must define dictionary "fields" into functions arguments
                which contains "FieldsName:FieldsValue" items, where:
                    
                    - FieldsName - name that you prompt from user.
                    - FieldsValue - default value or value that user input.
                    
            - Fields may be empty dictionary.
            
        First time template functions calls to get template for display
        user preview of you template, and pass empty fields=={}. You may change
        value of fields to take caller information about fields. If you do not change
        fields, then for fields value will be assigne it's names.
        Second time template-function will be called with entered fields
        dict as argument and you may use fields
        values that user entered or assigned by default.
        All fields are case insensitive, then parsing returned template.
                
        String "I{# Your code}" place into position for user input.
            
    All template's functions may have next attributes or other:
         
         - language - language for which template applicable.
         - categoty - category.
         - author - author of template.
         
    Attributes must be written precendence function code into comment in
    next style: B{# metainfoname = value}.
    Example::
        
        # language = python
        # category = Python
        # author = Mazhugin Aleksey
    
    Predefined and known by pluggin in C{./boa-pluggins/CodeTemplates.plug-in.py}
    metainfonames is I{language} and I{category}.
        
    For retrive source file path you must use C{codetpl_sourcefile} global
    variable which auto appending into module dictionary.
    
    If error occurs you may rise exception or return error description into
    template string. If you rise exception then exception type and text will be
    writed instead template.
    
    Loads all finded and right files.
    Last templates override previous with same names.
"""
        
__all__=['codetpl', 'guiCodeTpl']


