#!/usr/bin/env python
# -*- coding: utf-8 -*-
#-----------------------------------------------------------------------------
# Name:        XCodeTemplates.plug-in.py
# Purpose:     
#
# Author:      Mazhugin Aleksey
#
# Created:     2007
# RCS-ID:      $Id: CodeTemplates.plug-in.py 22 2008-12-01 17:05:27Z alex $
# Copyright:   (c) 2007
# Licence:     Public license agreement v1.0
#-----------------------------------------------------------------------------
#Boa:Dialog:CodeTemplateManagerDlg

##import XPyLIB.dbg as dbg ##@


# BUG: Boa bug  ??????????? !!!!!!!
# This plug-in not load, load partialy, not initialized, or initialized partialy
# then renamed to other name ?????????

"""
Code Template plug-in for Boa constructor.

Wrap L{XPyYools.codetpl.codetpl} Code template manager into Boa as plug-in.
"""

##dbg.fwriteln('IMPORT XCODETEMPLATES\n') ##@

import wx
import wx.stc

import os, glob, ConfigParser
import sys

import Preferences, Utils, Plugins
from Utils import _

import re

# Try import XPyLIB codetemplate package.
try:
    import XPyTools.codetpl.codetpl as codetpl
except:
    ##dbg.fwriteln('!!! IMPORT CODETPL Is FAIL\n') ##@
    pass
try:
    import XPyTools.codetpl.guiCodeTpl as guiCodeTpl
except:
    ##dbg.fwriteln('!!! IMPORT GUICODETPL Is FAIL\n') ##@
    pass


codeTemplatesUserListType = 1

class EventWrapper():
    """
    Wrapper class for event - for command (menu select or hotkey) ***template.
    
    Used its instance in which attribute B{fun} and B{val} is set from
    caller befor it do call.
    - fun - function that take 2 parameters: self and type of
        requested template.
    - val - type of requested template (str).
    """
    def DoEvent(self, e):
        self.fun(e, self.val)
        

class XCodeTemplatesViewPlugin:
    """
    Provides access to Code Templates to insert in a Source View.
    """
    
    def __init__ctm(self):
        """
        Init Codetemplates.
        """
        
        ##dbg.fwriteln('XCodeTemplatesViewPlugin.Init CodeTPL.') ##@
        
        # Init CodeTemplateMngr with default paths.
        ##dbg.fwriteln('Init CodeTemplateMngr with default paths.') ##@
        
        #: var ctm: Instance of code template manager.
        #: type ctm: L{XPyTools.codetpl.codtpl.CodeTemplateMngr}
        self._ctm=codetpl.CodeTemplateMngr([])
        ##dbg.fwriteln('_ctm.Types==', self._ctm.Types) ##@
        ##dbg.fwriteln('_ctm.Path==', self._ctm._CodeTemplateMngr__path) ##@
        
        # Init guiCodeTpl.
        ##dbg.fwriteln('Init guiCodeTpl.') ##@
        ##_gui=guiCodeTpl.CodeTplManagerDlg(None, self._ctm)
        
        # Prefix.
        pref=self._ctm.GetConfig('Prefs','typesprefix','type_')
        ##dbg.fwriteln('Prefix==', pref) ##@
        
         
        # Reloads.
        self.__reload=self._ctm.GetConfig('Prefs','ReloadTemplates','yes').upper() \
            in ('YES', 'TRUE', '1')
        
        # Get types.
        
        #: var _types: List of templates types.
        #: type _types: C{list}
        self._types=[]
        ##[ ( type, MenuName, HotKey, Interface, Name ) ]
        self._types = [ (t, self._ctm.GetConfig(pref+t,'MenuName',''), \
            self._ctm.GetConfig(pref+t,'HotKey',''), self._ctm.GetConfig(pref+t,'Interface','gui'), \
            self._ctm.GetConfig(pref+t,'Name',t) ) \
            for t in self._ctm.Types ]
            
        ##dbg.fwriteln('\nTypes==', str(self._types) ) ##@
        
        reHot=re.compile(r'((?P<acc>Alt|Ctrl|Shift)[-+])?(?P<ch>[A-Z0-9])', re.I)
        
        # Fill Preference.
        ##dbg.fwriteln('\nPreferences:') ##@ 
        ##Preferences.keyDefs['XCodeTemplates'] = (wx.ACCEL_ALT, ord('Q'), 'Alt-Q')
        for t in self._types: 
            ##dbg.fwriteln('\n    type=',t) ##@       
            if t[2]:  
                ##dbg.fwriteln('\n    match t[2]=',t[2]) ##@    
                m=reHot.match(t[2])
                ##dbg.fwriteln('\n    if t[2] == True') ##@
                if m:
                    ##dbg.fwriteln('\n    if m == True') ##@
                    acc=m.group('acc')
                    ch=m.group('ch')
                    assert ch ##@@
                    ##dbg.fwriteln('\n    Acc=',acc, '    ch=',ch) ##@
                    if acc:
                        acc=getattr( wx, 'ACCEL_'+acc.upper() )
                    else:
                        acc=wx.ACCEL_NORMAL
                    ch=ch.upper()
                    Preferences.keyDefs[ t[1] or ('Code Template ' + t[4]) ] = (acc, ord(ch), t[2])
        
        # Delete not needed variables.
##        del pref
##        del t
##        del reHot
##        del acc
##        del ch
##        del m

    def __init__(self, model, view, actions):
        """
        """
        ##dbg.fwriteln('\nXCode...Init') ##@
        
        # Inbit Code Template Manager.
        self.__init__ctm()
        
        ##dbg.fwriteln('\nXCode...Init model, view, action types is:', type(model), type(view),type(actions)) ##@
        self.model = model
        self.view = view
        
        ##[ ( type, MenuName, HotKey, Interface, Name ) ]
        ##dbg.fwriteln('\nXCode...Init for t in self._types:') ##@
        try:
            for t in self._types: 
                ##dbg.fwriteln('\n    XCode...Init() type=',str(t)) ##@
                ##dbg.fwriteln('\n    XCode...Init() hasattr=', hasattr(self,'OnXCodeTemplates') ) ##@
                if t[1]:
                    ##dbg.fwriteln('\nXCode...Init ift[1] add OnFunctions') ##@
                    # Create redirector for get names.
                    ##dbg.fwriteln('\n    XCode...Add onf=', t[0] ) ##@
                    ev=EventWrapper()
                    setattr(ev,'fun',self.OnXCodeTemplates)
                    setattr(ev,'val',t[0])
                    actions.append( (t[1], ev.DoEvent, '-', t[1]) )
                    # Register function for parse template.
                    self.view.Bind(wx.stc.EVT_STC_USERLISTSELECTION, self.OnXCodeTemplateSelected)
        except Exception, e:
            ##dbg.fwriteln('*** EXCEPTION *** ', e)
            pass

    def OnXCodeTemplates(self, event, type_):
        """
        Show requested template.
        
        @param event: Event object.
        @type event: ??? See into Boa...
        @param type_: Type of requested template.
        @type type_: str
        """
        # Reload templates if needed by config.
        # From config will be updated only Code Templates settings (paths, ...). 
        if self.__reload:
            self._ctm.Reload()
        ##dbg.fwriteln('\nXCode...OnCodeTemplates(type=', type_, ')') ##@
        i=-1
        ii=0
        ##dbg.fwriteln('\nXCode...OnCodeTemplates TEST TYPE:') ##@
        for t in self._types:
            ##dbg.fwriteln('\nXCode...OnCodeTemplates ,ii=',ii,'(',t[0],')==', type_) ##@
            if t[0]==type_:
                i=ii
                break
            ii+=1
        if i==-1:
            ##dbg.fwriteln('\nXCode...OnCodeTemplates NO SUCH INDEX ???') ##@
            # Wrong type ???
            return
        self.st=type_
        ##[ ( type, MenuName, HotKey, Interface, Name ) ]
        if self._types[i][3]=='list':
            ##dbg.fwriteln('\nXCode...OnCodeTemplates show list') ##@
            names = sorted( self._ctm.GetTemplates(type_,{'language':self.view.language}, True) )
            self.view.UserListShow(codeTemplatesUserListType, ' '.join(names))
        elif self._types[i][3]=='gui':
            # Show guiCodeTpl.
            ##dbg.fwriteln('\nXCode...OnCodeTemplates show gui') ##@
            try:
                self._gui=guiCodeTpl.CodeTplManagerDlg(None, self._ctm)
                self._gui.srcfile=self.model.filename
                self._gui.language=self.view.language
                self._gui.params={'model':self.model, 'view':self.view}
                ##dbg.fwriteln('\nXCode...OnCodeTemplates Language=', self._gui.language) ##@
                ##dbg.fwriteln('\nXCode...OnCodeTemplates t[i][4]==', self._types[i][4]) ##@
                # TODO: Do not work else. Add or fix.
                self._gui.init_name=self._types[i][4]
                # Reload controls for initializing changes.
                self._gui.ReloadCtrls()
                self._gui.ShowModal()
                if self._gui.result:
                    ##dbg.fwriteln('\nXCode...OnCodeTemplates gui result==:\n\n', self._gui.result, '\n\n') ##@
                    # Use current suorce indentation.
                    idnt = Utils.getIndentBlock()
                    self.view.insertCodeBlock(self._gui.result.replace('\t', idnt))
            finally:
                self._gui.Destroy()
                pass
        else:
            # No such interface.
            ##dbg.fwriteln('\nXCode...OnCodeTemplates BAD INTERFACE') ##@
            pass

    def OnXCodeTemplateSelected(self, event):
        ##dbg.fwriteln('\nXCode...OnXCodeTemplateSelected(type=', self.st, ')') ##@
        #? Boa pluggins BUG ??? This event called 3 times ???
        if self.st:
            type_=self.st
            self.st=''
            if event.GetListType() == codeTemplatesUserListType:
                ##dbg.fwriteln('\nXCode...OnXCodeTemplateSelected text==', event.GetText()) ##@
                tpl=self._ctm.ParseTemplate(type_, event.GetText(), {}, self.model.filename, \
                    {'model':self.model, 'view':self.view})
                ##dbg.fwriteln('\nXCode...OnXCodeTemplateSelected tpl==', tpl) ##@
                if tpl:
                    # If return non empty then insert into source code.
                    idnt = Utils.getIndentBlock()
                    self.view.insertCodeBlock(tpl.replace('\\t', idnt) )
        event.Skip()
            

from Views import SourceViews
SourceViews.EditorStyledTextCtrl.plugins += (XCodeTemplatesViewPlugin,)



