#!/usr/bin/env python
# -*- coding: utf-8 -*-
#--------------------------------------------------------------------
# Author: Mazhugin Aleksey
# Created: 2007/09/25
# ID: $Id: guiCodeTpl.py 20 2008-11-29 18:40:06Z alex $
# URL: $URL: file:///myfiles/svn_/XPyLIB/trunc/XPyTools/codetpl/guiCodeTpl.py $
# Copyright: Copyright (c) 2007, Mazhugin Aleksey
# License: BSD
#--------------------------------------------------------------------
#Boa:Dialog:CodeTplManagerDlg

"""
GUI Wrapper for L{XPyTools.codetpl.codetpl} Code template manager.
"""

import wx
from wx.lib.anchors import LayoutAnchors
import wx.grid
import codetpl
import os
##import XPyLIB.dbg as dbg ##@

##dbg.fwriteln('IMPORTING GUI CODETPL') ##@

[wxID_CODETPLMANAGERDLG, wxID_CODETPLMANAGERDLGTXTTPLNAME, 
 wxID_CODETPLMANAGERDLGCHOICELANG, wxID_CODETPLMANAGERDLGGRIDFIELDS, 
 wxID_CODETPLMANAGERDLGLBLDESCRIPTION, wxID_CODETPLMANAGERDLGLBLFIELDS, 
 wxID_CODETPLMANAGERDLGLBLINFORMATION, wxID_CODETPLMANAGERDLGSTATICLINE1, 
 wxID_CODETPLMANAGERDLGTOOLBARTAB, wxID_CODETPLMANAGERDLGTREETPLNAMES, 
 wxID_CODETPLMANAGERDLGTXTDESCRIPTION, wxID_CODETPLMANAGERDLGTXTINFORMATION, 
 wxID_CODETPLMANAGERDLGTXTPREVIEW 
] = [wx.NewId() for _init_ctrls in range(13)]

class CodeTplManagerDlg(wx.Dialog):
    """
    Dialog, main window of gui templates.
    
    For you may specify (set befor calling C{ShowModal()} dialog method)
    L{self.language} and L{self.srcfile} and L{self.init_name}
    for default language and source file for
    which called template.
    
    For setting of I{srcfile} and I{language} take effect you must call
    L{self.ReloadCtrls} before calling show dialog.
    
    I{init_name} - currently not work properly, but after fix in future
    must select toolbar tool as here given.
    
    For initialize this dialog you must additionaly get for parameters
    L{codetpl.CodeTemplateMngr} instance.
    """
    
#-------Initialization----------------------------------------------------------
    
    def _init_coll_bsMiddleRightTop_Items(self, parent):
        # generated method, don't edit

        parent.AddSizer(self.bsMiddleRightTopLeft, 1, border=0, flag=wx.EXPAND)
        parent.AddSizer(self.bsMiddleRightTopRight, 2, border=0, flag=wx.EXPAND)

    def _init_coll_bsMiddleRight_Items(self, parent):
        # generated method, don't edit

        parent.AddSizer(self.bsMiddleRightTop, 2, border=0, flag=wx.EXPAND)
        parent.AddWindow(self.lblFields, 0, border=2,
              flag=wx.ALL | wx.ADJUST_MINSIZE | wx.ALIGN_TOP | wx.ALIGN_LEFT)
        parent.AddWindow(self.gridFields, 3, border=2,
              flag=wx.ALL | wx.ALIGN_BOTTOM | wx.EXPAND | wx.ALIGN_LEFT)

    def _init_coll_bsMiddleRightTopLeft_Items(self, parent):
        # generated method, don't edit

        parent.AddWindow(self.lblInformation, 0, border=2,
              flag=wx.ALL | wx.ALIGN_LEFT | wx.ALIGN_CENTER_VERTICAL | wx.ADJUST_MINSIZE)
        parent.AddWindow(self.txtInformation, 1, border=2,
              flag=wx.ALL | wx.EXPAND| wx.ALIGN_LEFT)

    def _init_coll_bsTopSizer_Items(self, parent):
        # generated method, don't edit

        parent.AddWindow(self.toolBarTab, 0, border=2,
              flag=wx.ALL | wx.ALIGN_TOP)
        parent.AddWindow(self.staticLine1, 0, border=2, flag=wx.ALL)
        parent.AddSizer(self.bsMiddleSizer, 3, border=0, flag=wx.EXPAND)
        parent.AddWindow(self.txtPreview, 2, border=2,
              flag=wx.ALL | wx.EXPAND | wx.ALIGN_BOTTOM)
        if self.sizerButtonSizer:
            parent.AddSizer(self.sizerButtonSizer, 0, border=2, flag=0)

    def _init_coll_bsMiddleLeft_Items(self, parent):
        # generated method, don't edit

        parent.AddWindow(self.txtTplName, 0, border=2,
              flag=wx.ADJUST_MINSIZE | wx.EXPAND | wx.ALL | wx.ALIGN_TOP)
        parent.AddWindow(self.treeTplNames, 2, border=2,
              flag=wx.EXPAND | wx.ALL | wx.ALIGN_CENTER_VERTICAL)
        parent.AddWindow(self.choiceLang, 0, border=2,
              flag=wx.ADJUST_MINSIZE | wx.EXPAND | wx.ALL | wx.ALIGN_BOTTOM)

    def _init_coll_bsMiddleRightTopRight_Items(self, parent):
        # generated method, don't edit

        parent.AddWindow(self.lblDescription, 0, border=2,
              flag=wx.ALL | wx.ALIGN_CENTER_VERTICAL | wx.ALIGN_LEFT | wx.ADJUST_MINSIZE)
        parent.AddWindow(self.txtDescription, 1, border=2,
              flag=wx.ALL | wx.EXPAND| wx.ALIGN_RIGHT)

    def _init_coll_bsMiddleSizer_Items(self, parent):
        # generated method, don't edit

        parent.AddSizer(self.bsMiddleLeft, 3, border=0,
              flag=wx.EXPAND | wx.ALIGN_LEFT)
        parent.AddSizer(self.bsMiddleRight, 8, border=0,
              flag=wx.EXPAND | wx.ALIGN_RIGHT)

    def _init_sizers(self):
        # generated method, don't edit
        self.bsTopSizer = wx.BoxSizer(orient=wx.VERTICAL)

        self.bsMiddleSizer = wx.BoxSizer(orient=wx.HORIZONTAL)

        self.bsMiddleLeft = wx.BoxSizer(orient=wx.VERTICAL)

        self.bsMiddleRight = wx.BoxSizer(orient=wx.VERTICAL)

        self.bsMiddleRightTop = wx.BoxSizer(orient=wx.HORIZONTAL)

        self.bsMiddleRightTopLeft = wx.BoxSizer(orient=wx.VERTICAL)

        self.bsMiddleRightTopRight = wx.BoxSizer(orient=wx.VERTICAL)
        
        self.sizerButtonSizer = self.CreateSeparatedButtonSizer(wx.OK | wx.CANCEL)

        self._init_coll_bsTopSizer_Items(self.bsTopSizer)
        self._init_coll_bsMiddleSizer_Items(self.bsMiddleSizer)
        self._init_coll_bsMiddleLeft_Items(self.bsMiddleLeft)
        self._init_coll_bsMiddleRight_Items(self.bsMiddleRight)
        self._init_coll_bsMiddleRightTop_Items(self.bsMiddleRightTop)
        self._init_coll_bsMiddleRightTopLeft_Items(self.bsMiddleRightTopLeft)
        self._init_coll_bsMiddleRightTopRight_Items(self.bsMiddleRightTopRight)

        self.SetSizer(self.bsTopSizer)

    def _init_ctrls(self, prnt):
        # generated method, don't edit
        wx.Dialog.__init__(self, id=wxID_CODETPLMANAGERDLG,
              name=u'CodeTplManagerDlg', parent=prnt, pos=wx.Point(-1, -1),
              size=wx.Size(888, 700),
              style=wx.RESIZE_BORDER | wx.DEFAULT_DIALOG_STYLE,
              title=u'Code template manager')
        self.SetClientSize(wx.Size(880, 673))
        self.SetToolTipString(u'')
        self.SetHelpText(u'')
        self.SetThemeEnabled(True)

        self.toolBarTab = wx.ToolBar(id=wxID_CODETPLMANAGERDLGTOOLBARTAB,
              name=u'toolBarTab', parent=self, pos=wx.Point(2, 2),
              size=wx.Size(788, 30),
              style=wx.TB_NOICONS | wx.TB_TEXT | wx.TB_HORIZONTAL)
        self.toolBarTab.SetFont(wx.Font(10, wx.SWISS, wx.NORMAL, wx.BOLD, False,
              u'MS Shell Dlg 2'))
        self.toolBarTab.SetThemeEnabled(False)
        self.toolBarTab.SetToolTipString(u'')
        self.toolBarTab.SetHelpText(u'Change code template mode')
        self.toolBarTab.SetLabel(u'')
        self.toolBarTab.SetToolPacking(0)
        self.toolBarTab.SetMaxSize(wx.Size(-1, -1))
        self.toolBarTab.SetMinSize(wx.Size(788, -1))

        self.txtPreview = wx.TextCtrl(id=wxID_CODETPLMANAGERDLGTXTPREVIEW,
              name=u'txtPreview', parent=self, pos=wx.Point(2, 361),
              size=wx.Size(776, 209),
              style=wx.STATIC_BORDER | wx.VSCROLL | wx.HSCROLL | wx.TE_READONLY | \
                wx.TE_MULTILINE | wx.TE_DONTWRAP | wx.ALWAYS_SHOW_SB | wx.TE_RICH,
              value='textCtrl1') ##
        self.txtPreview.SetToolTipString(u'Preview code.')
        # Monospace text.
        f=wx.Font(pointSize=-1, family=wx.FONTFAMILY_MODERN, \
            style= wx.FONTSTYLE_NORMAL, weight=wx.FONTWEIGHT_NORMAL)
        f=wx.TextAttr(font=f)
        f.SetFlags(wx.TEXT_ATTR_FONT)
        self.txtPreview.SetDefaultStyle(f)            

        self.txtTplName = wx.TextCtrl(id=wxID_CODETPLMANAGERDLGTXTTPLNAME, name=u'txtTplName',
              parent=self, pos=wx.Point(2, 42), size=wx.Size(256, 21), style= wx.TE_PROCESS_ENTER | \
                wx.WANTS_CHARS, \
              value='txtTplName') ##wx.CB_DROPDOWN | wx.CB_READONLY
        self.txtTplName.SetToolTipString(u'Select arrows or enter template name.')
        ##self.Bind(wx.EVT_COMBOBOX, self.OncbTplNameComboBox, id=wxID_CODETPLMANAGERDLGTXTTPLNAME)
        self.Bind(wx.EVT_TEXT, self.OntxtTplNameText, id=wxID_CODETPLMANAGERDLGTXTTPLNAME)
        self.Bind(wx.EVT_TEXT_ENTER, self.OntxtTplNameEnter, id=wxID_CODETPLMANAGERDLGTXTTPLNAME)
        
        # TODO: Add Arrow and Back keys handler.
        #? Never handle events ???
        ##self.Bind(wx.EVT_CHAR, self.OntxtTplNameChar) ##, id=wxID_CODETPLMANAGERDLGTXTTPLNAME)
        #? Handle events only then grid is focused ???
        ##self.Bind(wx.EVT_KEY_DOWN, self.OntxtTplNameChar) ##, id=wxID_CODETPLMANAGERDLGTXTTPLNAME)
        

        self.treeTplNames = wx.TreeCtrl(id=wxID_CODETPLMANAGERDLGTREETPLNAMES,
              name=u'treeTplNames', parent=self, pos=wx.Point(2, 67),
              size=wx.Size(256, 265),
              style=wx.STATIC_BORDER | wx.VSCROLL | wx.HSCROLL | wx.ALWAYS_SHOW_SB | wx.TR_HAS_BUTTONS | \
                wx.TR_FULL_ROW_HIGHLIGHT | wx.TR_ROW_LINES | wx.TR_SINGLE | wx.TR_HAS_BUTTONS)
        self.treeTplNames.SetToolTipString(u'Tree of templates by category. You may select template here.')
        self.treeTplNames.SetQuickBestSize(True)
        self.Bind(wx.EVT_TREE_SEL_CHANGED, self.OntreeTplNamesSelChanged, id=wxID_CODETPLMANAGERDLGTREETPLNAMES)

        self.choiceLang = wx.Choice(choices=[],
              id=wxID_CODETPLMANAGERDLGCHOICELANG, name=u'choiceLang',
              parent=self, pos=wx.Point(2, 336), size=wx.Size(256, 21),
              style=0)
        self.choiceLang.SetToolTipString(u'Select language. Usualy not needed (select auto).')
        self.Bind(wx.EVT_CHOICE, self.OnChoiceSelected, id=wxID_CODETPLMANAGERDLGCHOICELANG)

        self.lblFields = wx.StaticText(id=wxID_CODETPLMANAGERDLGLBLFIELDS,
              label=u'Fields:', name=u'lblFields', parent=self,
              pos=wx.Point(262, 162), size=wx.Size(31, 13), style=0)
        self.lblFields.SetToolTipString(u'')
        self.lblFields.SetMinSize(wx.Size(-1, -1))

        self.gridFields = wx.grid.Grid(id=wxID_CODETPLMANAGERDLGGRIDFIELDS,
              name=u'gridFields', parent=self, pos=wx.Point(262, 179),
              size=wx.Size(516, 177),
              style=wx.VSCROLL | wx.HSCROLL | wx.ALWAYS_SHOW_SB)
        self.gridFields.SetToolTipString(u'')
        self.gridFields.CreateGrid(5, 1, 0) ##wx.grid.SelectCells
        self.gridFields.SetColLabelValue(0, '  Field value  ')
        w1=self.gridFields.GetColSize(0)
        self.gridFields.SetRowLabelAlignment(wx.ALIGN_LEFT, wx.ALIGN_CENTER)
        self.gridFields.SetColSize(0,w1*5.5)
        self.gridFields.SetRowLabelSize(w1*2)
        
        self.Bind(wx.grid.EVT_GRID_CELL_CHANGE, self.OngridCellChange)
        #? Id error then bind _CMD_ ?
        ##self.Bind(wx.grid.EVT_GRID_CMD_CELL_CHANGE, self.OngridCellChange, wxID_CODETPLMANAGERDLGGRIDFIELDS)

        self.staticLine1 = wx.StaticLine(id=wxID_CODETPLMANAGERDLGSTATICLINE1,
              name='staticLine1', parent=self, pos=wx.Point(2, 36),
              size=wx.Size(788, 2), style=wx.LI_HORIZONTAL)
        self.staticLine1.SetConstraints(LayoutAnchors(self.staticLine1, True,
              True, False, False))
        self.staticLine1.SetToolTipString(u'')

        self.lblInformation = wx.StaticText(id=wxID_CODETPLMANAGERDLGLBLINFORMATION,
              label=u'Information:', name=u'lblInformation', parent=self,
              pos=wx.Point(262, 42), size=wx.Size(60, 13), style=0)
        self.lblInformation.SetToolTipString(u'')
        self.lblInformation.SetMinSize(wx.Size(-1, -1))

        self.lblDescription = wx.StaticText(id=wxID_CODETPLMANAGERDLGLBLDESCRIPTION,
              label=u'Description', name=u'lblDescription', parent=self,
              pos=wx.Point(522, 42), size=wx.Size(53, 13), style=0)
        self.lblDescription.SetToolTipString(u'')
        self.lblDescription.SetMinSize(wx.Size(-1, -1))

        self.txtInformation = wx.TextCtrl(id=wxID_CODETPLMANAGERDLGTXTINFORMATION,
              name=u'txtInformation', parent=self, pos=wx.Point(262, 59),
              size=wx.Size(256, 99), style=wx.STATIC_BORDER | wx.TE_MULTILINE | wx.TE_READONLY | \
              wx.TE_RICH,
              value=u'textCtrl2')
        self.txtInformation.SetToolTipString(u'')

        self.txtDescription = wx.TextCtrl(id=wxID_CODETPLMANAGERDLGTXTDESCRIPTION,
              name=u'txtDescription', parent=self, pos=wx.Point(522, 59),
              size=wx.Size(256, 99), style=wx.STATIC_BORDER | wx.TE_MULTILINE | \
                wx.TE_READONLY, value='textCtrl3')
        self.txtDescription.SetToolTipString(u'')

        self._init_sizers()
        
        ##Bind Std Buttons
        self.Bind(wx.EVT_BUTTON, self.OnOk, id=wx.ID_OK)
        self.Bind(wx.EVT_BUTTON, self.OnCancel, id=wx.ID_CANCEL)
        # Bind Activate event.
        self.Bind(wx.EVT_ACTIVATE, self.OnActivate)

    def __init__(self, parent, ctm):
        """
        @param ctm: XPyTools.codetpl.codetpl.CodetemplateMngr instance.
        @type ctm: L{XPyTools.codetpl.codetpl.CodetemplateMngr}
        """
        
        ##dbg.fwriteln('\n GUI INIT \n') ##@
        
        self._init_ctrls(parent)
        # Load icon.
        icofile='codetpl.bmp'
        path=os.path.join(os.path.dirname(__file__),icofile)
        ##wx.InitAllImageHandlers()
        if os.path.exists(path):
            icon=wx.Icon(path,wx.BITMAP_TYPE_ICO,-1,-1)
        else:
            icon=wx.NullIcon
        self.SetIcon(icon)
        
        # Init CodeTemplateManager.
        # Use default template and config location.  
        
        #: @ivar: XPyTools.codetpl.codetpl.CodetemplateMngr instance.
        #: @type: L{XPyTools.codetpl.codetpl.CodetemplateMngr}
        self.ctm=ctm
        
        
        # Init variables.
        
        #: @ivar: Available types: its names and descriptions.
        #: @type: dict{'name' : ('type', 'desc', 'sectionname',ID)} = {}
        self.__types={}
        
        #: @ivar: Fields for passing to template function..
        #: @type: str=C{{}}
        self.__fields={}
        
        #: @ivar: Default language for templates selection.
        #: @type: str = L{codetpl.ANY}
        self.__lang=codetpl.ANY
        
        #: @ivar: Currently selected type (tool).
        #: @type: str = C{''}
        self.__type=''
        
        #: @ivar: Init toolbar button name (select then show to user).
        #: @type: str = C{''}
        self.init_name=''
        
        #: @ivar: Templates names shown in txtTplName.
        #: @type: list =C{[str]}
        self.__tpls=[]
        
        #: @ivar: Templates names shown in txtTplName.
        #: @type: C{list[wx.TreeItemId]}
        self.__tplsid=[]
        
        #: @ivar: Previous value entered into txtTplName.
        #: @type: str = C{''}
        self.__prevval=''
        
        #: @ivar: If True then txtTplName not be set when tree change selection.
        #: @type: bool=C{False}
        self.__nomodtxt=False
        
        #: @ivar: Source file for use in templates.
        #:     I{You may set this variable from caller}.
        #: @type: str = C{''}
        self.srcfile='SRCFILE'
        
        #: @ivar: Additional parameters for templates.
        #:     I{You may set this variable from caller}.
        #: @type: dict = {}
        self.params={}
        
        #: @ivar: Default language for templates. Selected by default when
        #:     dialog opened. If no such lunguage then select first finded.
        #:     I{You may set this variable from caller}.
        #: @type: str = C{L{codetpl.ANY}}
        self.language=codetpl.ANY
        
        #: @ivar: Result from template calling.
        #: @type: str = C{''}
        self.result=''
        
        # Reload toolbar.
        self.ReloadToolbar()

        # Reload controls.
        self.ReloadCtrls()
        
#-------Re/Load controls--------------------------------------------------------

        
    def ReloadToolbar(self):
        """
        Reload toolbars buttons and etc.
        
        Usualy call if CodeTemplateManager was reloaded.
        """
        # Clear current toolbar and variables.
        self.__types.clear()
        self.toolBarTab.ClearTools()
        
        ##dbg.writeln('\n**** ReloadToolbar') ##@
        
        # Create/load new toolbar and variables.
        pref=self.ctm.GetConfig('Prefs','typesprefix','type_')
        ##dbg.writeln('\n**** ReloadToolbar, types==', self.ctm.Types) ##@
        # Assign dict{'name' : ('type', 'desc', 'sectionname', wxID, ToolID)}
        for t in self.ctm.Types:
            name=self.ctm.GetConfig(pref+t,'Name',t)
            desc=self.ctm.GetConfig(pref+t,'Desc','')
            wxID=wx.NewId()
            # Add toolbars wxITEM_RADIO
            ToolID=self.toolBarTab.DoAddTool(bitmap=wx.NullBitmap, bmpDisabled=wx.NullBitmap,
                  id=wxID, kind=wx.ITEM_RADIO,
                  label=name, longHelp=u'', shortHelp=desc).GetId()
            self.Bind(wx.EVT_TOOL, self.OnToolBarTabCodeTool,
                  id=wxID)
            self.__types[name] = (t, desc, pref+t, wxID, ToolID)    
        
        if (len(self.__types) > 0):
                if not self.init_name and not self.__types.has_key(self.init_name):
                    self.init_name=self.__types.keys()[0]
                self.__type=self.__types[self.init_name][0]
                self.toolBarTab.ToggleTool(self.__types[self.init_name][4], True)
                
        self.toolBarTab.Realize()
        
    def ReloadCtrls(self):
        """
        Reload controls content.
        
        1st stage: reload choiceLang.
        """
        ##dbg.writeln('\n*** CTRLS1\n') ##@
        
        # Clear all, first.
        self.txtTplName.ChangeValue('')
        self.choiceLang.Clear()
        self.treeTplNames.DeleteAllItems()
        self.txtDescription.Clear()
        self.txtInformation.Clear()
        self.txtPreview.Clear()
        self.result=''
        self.__tpls=[]
        self.__tplsid=[]
        self.__prevval=''
        self.__nomodtxt=False
        self.ClearGrid()
        
        # Stop reload if no types selected.
        if not type:
            return
        
        # Get languages.
        lang=self.ctm.GetMetaAllValues(self.__type, 'language')
        ##dbg.fwriteln('\n LANG==',lang) ##@
        lang.sort()
        if codetpl.ANY in lang:
            lang.remove(codetpl.ANY)
        lang.append(codetpl.ANY) ## Last in list for any values.
        self.choiceLang.AppendItems(lang)
        if self.language:
            self.__lang=self.language
        ##dbg.fwriteln('\n self.LANG==',self.language) ##@
        ##dbg.fwriteln('\n srcfile==',self.srcfile) ##@
        i=self.choiceLang.FindString(self.__lang)
        ##dbg.writeln('\n LANG i==',i) ##@
        if i==wx.NOT_FOUND:
            i=0
        self.choiceLang.SetSelection(i)
        self.__lang=self.choiceLang.GetStringSelection()
        # Test and set 'any' language.
        assert self.__lang!='' ##@@
        # Continue loading.
        self.ReloadCtrls2()
        
    def ReloadCtrls2(self):
        """
        Reload controls.
        Stage 2: Reload all exclude choiceLang.
        """
        ## __types==dict{'name' : ('type', 'desc', 'sectionname',ID)}
        # Clear list.
        
        ##dbg.writeln('\n*** CTRLS2\n') ##@
        self.__tpls=[]
        self.__tplsid=[]
        self.__prevval=''
        self.__nomodtxt=False
        self.result=''
        self.txtTplName.ChangeValue('')
        self.treeTplNames.DeleteAllItems()
        
        # Fill TplNames.
        
        # If language selected then show only items with same language
        # value, else show all items, also without language info.
        f={'language':self.__lang}
        ##dbg.writeln('\n LANG==', self.__lang) ##@
        tpls=self.ctm.GetTemplates(self.__type, f, self.__lang==codetpl.ANY)
        tpls.sort()
        
        # Get categories and it's templates.
        
        # Uppend ancategorized root.
        cat={'Unknown':[]}
        # Loop throw selected templates.
        for t in tpls:
            ## ('docstr', {'metaname' : 'metavalue'})
            mi=self.ctm.GetMetaInfo(self.__type, t)
            if mi[1].has_key('category'):
                c=mi[1]['category']
            else:
                c='Unknown'
            # Place 'any' category to unknown.
            if c==codetpl.ANY or c=='':
                c='Unknown'
            if not cat.has_key(c):
                cat[c]=[]
            cat[c].append(t)
        ##end for t
            
        # Fill tree.
        self.__tpls=[]
        self.__tplsid=[]
        r=self.treeTplNames.AddRoot('Templates')
        self.treeTplNames.SetItemBold(r)
        for k,v in cat.items():
            if v:
                f=self.treeTplNames.AppendItem(r, k)
                self.treeTplNames.SetItemBold(f)
                for t in v:
                    # Save tpls for future using.
                    self.__tpls.append(t)
                    self.__tplsid.append(self.treeTplNames.AppendItem(f, t))
                ##end for t
            ##end if v
        ##end for k,v
        self.treeTplNames.Expand(r)
        self.txtTplName.SetFocus()
    
    def ClearGrid(self):
        """
        Clear grid.
        """
        # Clear grid.
        self.gridFields.ClearGrid()
        nr=self.gridFields.GetNumberRows()
        for i in xrange(nr):
            self.gridFields.SetRowLabelValue(i,'')
                
    def FillGrid(self):
        """
        You must clear grid if need by calling L{self.ClearGrid}.
        """
        nr=self.gridFields.GetNumberRows()
        # Fill grid.
        i=0
        for k,v in self.__fields.items():
            if i >= nr:
                nr+=1
                self.gridFields.AppendRows(1)
            self.gridFields.SetRowLabelValue(i,k)
            self.gridFields.SetCellValue(i, 0, v)
            i+=1
        ##end for
        
    def ValidateTxt(self, txt):
        """
        Validate with whole templates name and partial.
        For partial validation return fist equal template name.
        
        @param txt: Text for validation with templates name.
        @type txt: str
        @return: liked template name if text is valid or empty string.
        @rtype: str
        """
        for i in self.__tpls:
            if i.startswith(txt):
                return i
            ##end if
        ##end for
        return ''
    
    def Preview(self):
        """
        Fill controls for priview.
        
        Before calling preview you must set or clear L{self.__fields}.
        If need you must fill Fields grid by calling L{self.FillGrid}.
        
        @note: If error rised then return error message as template string.
        """
        # Clear controls.
        self.txtDescription.Clear()
        self.txtInformation.Clear()
        self.txtPreview.Clear()
        
        sel=self.treeTplNames.GetSelection()
        #? wxPython BUG??? not work
        if not sel.IsOk:
            return
        # Bug fix.
        if not self.txtTplName.Value:
            return
        t=self.treeTplNames.GetItemText(sel)
        if not self.ValidateTxt(t):
            return
        # Get metainfo.
        d,m=self.ctm.GetMetaInfo(self.__type, t)
        self.txtDescription.AppendText(d)
        # Default style
        fb=wx.Font(pointSize=-1, family=wx.FONTFAMILY_DEFAULT, \
            style=wx.FONTSTYLE_NORMAL, weight=wx.FONTWEIGHT_BOLD)
        fn=wx.Font(pointSize=-1, family=wx.FONTFAMILY_DEFAULT, \
            style=wx.FONTSTYLE_NORMAL, weight=wx.FONTWEIGHT_NORMAL)
        sb=wx.TextAttr(font=fb)
        sb.SetFlags(wx.TEXT_ATTR_FONT_WEIGHT)
        sn=wx.TextAttr(font=fn)
        sn.SetFlags(wx.TEXT_ATTR_FONT_WEIGHT)
        for k,v in m.items():
            self.txtInformation.SetDefaultStyle(sb)
            self.txtInformation.AppendText(k.capitalize()+': ')
            self.txtInformation.SetDefaultStyle(sn)
            self.txtInformation.AppendText(v+'\n')
        try:
            d=self.ctm.ParseTemplate(self.__type, t, self.__fields, self.srcfile, self.params)
            ##dbg.fwriteln('Preview srcfile==', self.srcfile) ##@
        except codetpl.codetplArgumentError, e:
            # If error raised then return error message as template text.
            d='ERROR: ' + str(e)
        self.txtPreview.AppendText(d)
        # Show start of text.
        self.txtPreview.ShowPosition(0)
        
    
#-------Event handlers----------------------------------------------------------
    

    def OnToolBarTabCodeTool(self, event):
        """
        Toolbar events handler.
        
        For all toolbar buttons (types) for preview and code
        calculate called B{toolhandler_}I{type}.
        By default calling L{toolhandlerdefault} with parameter preview.
        """
        id=event.GetId()
        tool=self.toolBarTab.FindById(id)
        name=tool.Label
        assert self.__types.has_key(name) ##@@
        self.__type=self.__types[name][0]
        self.ReloadCtrls()
        event.Skip()        
        
    def OnChoiceSelected(self, event):
        """
        Language changed.
        """
        ##dbg.writeln('\n*** CHOICE\n') ##@
        self.__lang=event.GetString()
        assert self.__lang!='' ##@@
        self.ReloadCtrls2()
        event.Skip()
        
    def OntreeTplNamesSelChanged(self, treeevent):
        """
        Tree selection changed.
        """
        ##dbg.writeln('\n*** TREE\n') ##@
        sel=treeevent.GetItem()
        t=self.treeTplNames.GetItemText(sel)
        # If set from partial txtTplName then no update txtTplName
        if self.ValidateTxt(t) and not self.__nomodtxt:
            self.txtTplName.ChangeValue(t)
            self.txtTplName.SetInsertionPointEnd()
        self.__nomodtxt=False
        # Show preview.
        self.__fields={}
        self.Preview()
        self.ClearGrid()
        self.FillGrid()
        treeevent.Skip()
        
    def OntxtTplNameText(self, event=None):
        """
        Validate input to existing templates.
        
        @Note: C{event} may be None if method called from code for validating.
        """
        ##dbg.writeln('\n*** TEXT\n') ##@
        t=self.txtTplName.GetValue()
        if t in self.__tpls:
            self.__nomodtxt=True
            self.treeTplNames.SelectItem(self.__tplsid[self.__tpls.index(t)])
            self.__prevval=t
        else:
            i=self.ValidateTxt(t)
            if i:
                # Help : append and select first equivalent name.
                self.__prevval=t
                self.__nomodtxt=True
                self.treeTplNames.SelectItem(self.__tplsid[self.__tpls.index(i)])
                self.txtTplName.ChangeValue(i)
                self.txtTplName.SetSelection(len(t), -1)
            else:
                # Not valid, change to previous.
                self.txtTplName.ChangeValue(self.__prevval)
                self.txtTplName.SetInsertionPointEnd()
        ##end if
        if event:
            event.Skip()
    
    # TODO: Implement Arrow and Back keys handler.    
    def OntxtTplNameChar(self, keyevent):
        """
        """
        kc=keyevent.GetKeyCode()
        ##self.txtPreview.AppendText('\n KEY=='+str(kc)) ##@
        dbg.writeln('Key Event hand, key code=', str(kc))
        keyevent.Skip()
        
    def OntxtTplNameEnter(self, event):
         """
         Enter pressed, work for templates
         and end modal.
         """
         dbg.writeln('Enter pressed')
         if self.txtTplName.Value:
             self.DoAction()
             self.EndModal(1)
         else:
             self.result=''
             self.EndModal(0)
         event.Skip()   
        
    def DoAction(self):
        """
        Call handler for working with selected template.
        
        If find method named B{toolbarhandler_I{typ}}, where typ - template type,
        then call it, else call default handler L{toolhandlerdefault}.
        """
        self.result=''
        # Fill fields.
        ##self.__fields={}
        # Get handler and call it if find.
        hname='toolbarhandler_' + self.__type
        h=getattr(self, hname, None)
        try:
            if h:
                h()
            else:
                # Commont default handler
                self.toolhandlerdefault()
            ##end if h
        except Exception, e:
            self.result='ERROR: '+str(e)
    
    def OngridCellChange(self, gridevent):
        """
        Field value changed event.
        
        Update L{self.__fields}, and preview.
        """
        k=self.gridFields.GetRowLabelValue( gridevent.GetRow() )
        v=self.gridFields.GetCellValue( gridevent.GetRow(), gridevent.GetCol() )
        if self.__fields.has_key(k):
            self.__fields[k]=unicode(v) #:PATCH: Unicode.
        self.Preview()
        gridevent.Skip()
        
    def OnOk(self, event):
        """
        Okey event/button.
        
        @return: 1 == True.
        """
        self.DoAction()
        self.EndModal(1)
        # Close dialog by default eventhandler.
        event.Skip()
        
    def OnCancel(self, event):
        """
        Cancel event/button.
        
        @return: 0 == False.
        """
        self.result=''
        # Return False for canceling.
        self.EndModal(0)
        # Close dialog by default eventhandler.
        event.Skip()
         
         
    def OnActivate(self, event):
        """
        Try select tool then window activated.
        """
        ##dbg.writeln('\n*** ACTIVATE *********') ##@
        event.Skip()
        return
        #? Can't select tool ???
        if event.GetActive() or True:
            ##dbg.writeln('\n**** Activate name== "', self.init_name, '" len=', len(self.__types)) ##
            # Select tool.
            ##dbg.writeln('\n**** Activate, types==', self.__types) ##@
            if (len(self.__types) > 0):
                if not self.init_name and not self.__types.has_key(self.init_name):
                    self.init_name=self.__types.keys()[0]
                id=self.__types[self.init_name][4]
                ##dbg.writeln('\n**** Select tool') ##@
                self.__type=self.__types[self.init_name][0]
                ##dbg.writeln('\n**** Tool state=', self.toolBarTab.GetToolState(id) ) ##@
                self.toolBarTab.ToggleTool(self.__types[self.init_name][4], True)
                self.toolBarTab.Realize()
                ##dbg.writeln('\n**** Tool state=', self.toolBarTab.GetToolState(id) ) ##@
                self.toolBarTab.Realize()
                tool=self.toolBarTab.FindById(id)
                ##dbg.writeln('\n**** ToolBase toggled=', tool.IsToggled() ) ##@
                       
        event.Skip()
        
        
#-------ToolHandlers------------------------------------------------------------
#
# Must have name B{toolhandler_I{typ}} where I{typ} - template type.
# Must return result into variable L{self.result} - string.
# If return C{''} - empty string, then no code paste into source.
#

##    def toolbarhandler_kwd(self):
##        ## self.txtPreview.AppendText('*** KWD ***\n') ##@
##        pass
##        
##    def toolhandler_new(self):
##        ## self.txtPreview.AppendText('*** NEW ***\n') ##@
##        pass
##        
##    def toolhandler_act(self):
##        ## self.txtPreview.AppendText('*** ACT ***\n') ##@
##        pass
##        
##    def toolhandler_tpl(self):
##        ## self.txtPreview.AppendText('*** TPL ***\n') ##@
##        pass
##        
##    def toolhandler_wzd(self):
##        ## self.txtPreview.AppendText('*** WZD ***\n') ##@
##        pass

    def toolhandlerdefault(self):
        """
        Default tool handler.
        
        If template function return '' then it's not needed to paste template.
        Usualy used for wizard, action and etc.
        """
        sel=self.treeTplNames.GetSelection()
        #? pyWindow BUG??? not work.
        if not sel.IsOk:
            return
        # Bug fix.
        if not self.txtTplName.Value:
            return
        t=self.treeTplNames.GetItemText(sel)
        if not self.ValidateTxt(t):
            return
        self.result=self.ctm.ParseTemplate(self.__type, t, self.__fields, self.srcfile, self.params)

        
#------Gui Test-----------------------------------------------------------------


        
if __name__=='__main__':
    app=wx.PySimpleApp()
    
##    dlg=CodeTplManagerDlg(None, \
##        codetpl.CodeTemplateMngr([r'E:/alex/Bag/XPyLIB/XPyTools/codetpl/templates', \
##        r'H:/Alex/vs/XPyLIB/XPyTools/codetpl/templates']) )
        
    dlg=CodeTplManagerDlg(None, \
        codetpl.CodeTemplateMngr() )

    try:
        ##dlg.init_name='New'
        setattr(dlg, 'init_name','New')
        ##dbg.writeln('\n dir(dlg)==', 'init_name' in dir(dlg)) ##@
        ##dbg.writeln('init_name=', dlg.init_name) ##@
        dlg.ShowModal()
        ##dbg.writeln('\n','='*60,'\nRESULT:\n', dlg.result)
        pass
    finally:
        dlg.Destroy()
        pass
    
    

