#!/usr/bin/env python
# -*- coding: utf-8 -*-
#--------------------------------------------------------------------
# Author: Mazhugin Aleksey
# Created: 2007/09/24
# ID: $Id: new_license.py 7 2007-11-15 18:12:30Z alex $
# URL: $URL: file:///H:/svn_/XPyLIB/trunc/XPyTools/codetpl/templates/new_license.py $
# Copyright: Copyright (c) 2007, Mazhugin Aleksey
# License: BSD
#--------------------------------------------------------------------

"""
Templates for licenses.
"""

# language = any
# category = license
# author = Mazhugin Aleksey
def new_lic_public_v1(fields):
    """
    Public Software Licence Agreement, Version 1.
    
    It's generic license by author Mazhugin Aleksey.
    """
    
    template='''
  Public Software Licence Agreement, Version 1
  ============================================

    Everyone is permitted to copy and distribute any copies
    of this licence document, but changing it is not allowed.
    Notice: For adaptation this license for you Software you may
    change "Author" and "Software" names and Author's notice of copyright.

    This license agreement is between the @Author@
    ("Author"), and the Individual or Organization ("Licensee") accessing and
    otherwise using "@Software@" software in source or binary form and its
    associated documentation ("Program").
  
  I. License for use and distribution Program
  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    This Program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This Program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 

  II. Exception notice
  ~~~~~~~~~~~~~~~~~~~~

    1. The exception is that you may use, copy, link, modify and distribute
    or otherwise use Program alone or in any derivative version under the
    user's own terms, works based on the Program however, that Author's
    License Agreement, GPL license and Author's notice of copyright, i.e.,
    "Copyright (c) @Year@ @Author@;"  are retained in Program
    alone or in any derivative version prepared by Licensee.

'''
    return template



# language = any
# category = license
# author = Mazhugin Aleksey
def new_lic_bsd(fields):
    """
    BSD license.
    """
    
    template='''
Copyright (c) @Year@, @Author@

All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.
    * Neither the name of the @Author@ nor the names of its contributors may be
      used to endorse or promote products derived from this software without
      specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
'''
    return template
    
    