#!/usr/bin/env python
# -*- coding: utf-8 -*-
#--------------------------------------------------------------------
# Author: Mazhugin Aleksey
# Created: 2007/09/24
# ID: $Id: new_module.py 9 2007-11-20 07:31:14Z alex $
# URL: $URL: file:///H:/svn_/XPyLIB/trunc/XPyTools/codetpl/templates/new_module.py $
# Copyright: Copyright (c) 2007, Mazhugin Aleksey
# License: BSD
#--------------------------------------------------------------------

"""
Templates for new modules.
"""

# language = python
# category = testing
# author = Mazhugin Aleksey
def new_unittest(fields):
    """
    UnitTest module template.
    """
    if not fields:
        fields['Module']='Module'
        fields['Coding']='utf-8'
    template='''
#!/usr/bin/env python
# -*- coding: @Coding@ -*-
#--------------------------------------------------------------------
# Filname: @FileName@
# Author: @Author@
# Created: @Date@
# ID: $Id'''+''': $
# URL: $URL'''+''': $
# Copyright: @Copyright@
# License: @License@
#--------------------------------------------------------------------

"""
Unit test for @Module@.
"""

# Importing
import @Module@ as tm # Testing module.
import unittest
import XPyLIB.dbg as dbg ##@

# Start test

class Test@Module@(unittest.TestCase):
    """@Summary@"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def test_Method(self):
        # Your code


# End test

if __name__=='__main__':
    unittest.main(argv=['','-v']) # Verbosity.
'''
    return template




# language = python
# category = module
# author = Mazhugin Aleksey
def new_module(fields):
    """
    Module template.
    """
    if not fields:
        fields['Coding']='utf-8'
    template='''
#!/usr/bin/env python
# -*- coding: @Coding@ -*-
#--------------------------------------------------------------------
# Filname: @FileName@
# Author: @Author@
# Created: @Date@
# ID: $Id'''+''': $
# URL: $URL'''+''': $
# Copyright: @Copyright@
# License: @License@
#--------------------------------------------------------------------

"""
@Summary@

Details...
"""

# Importing
import XPyLIB.dbg as dbg ##@

# Start Implementation

# Your code

# End Implemetation

#-DEBUG-START-------------------------------------------------------------------

def _debug():
    """
    """
    ## dbg.writeln( '\\n    ---- DEBUG ----    \\n' )
    pass
    
#-DEBUG-END---------------------------------------------------------------------

if __name__=='__main__':
    _debug()
    
'''
    return template

# language = python
# category = module
# author = Mazhugin Aleksey
def new_modulexlog(fields):
    """
    Module template.
    """
    if not fields:
        fields['Coding']='utf-8'
    template='''
#!/usr/bin/env python
# -*- coding: @Coding@ -*-
#--------------------------------------------------------------------
# Filname: @FileName@
# Author: @Author@
# Created: @Date@
# ID: $Id'''+''': $
# URL: $URL'''+''': $
# Copyright: @Copyright@
# License: @License@
#--------------------------------------------------------------------

"""
@Summary@

Details...
"""

# Importing
#import XPyLIB.dbg as dbg ##@
import XPyLIB

##:LOGGING:start
import XPyLIB.xlogging as _xlog
from functools import wraps
_log=_xlog.getLogger(__name__)
_log.disabled=0
_log_u=_xlog.IndentFormatter.lvlup
_log_d=_xlog.IndentFormatter.lvldown
_log_r=_xlog.IndentFormatter.lvlreset
_log_w=_xlog.IndentFormatter.lvlwrap
def _log_wl(fun):
    @wraps(fun)
    def wrapper(*args, **kwds):
        return _xlog.IndentFormatter.lvlwraplog(fun,_log)(*args, **kwds)
    return wrapper
##:LOGGING:end


# Start Implementation

# Your code

# End Implemetation

#-DEBUG-START-------------------------------------------------------------------

def _debug():
    """
    """
    ## _log.debug('Debug message')
    pass
    
#-DEBUG-END---------------------------------------------------------------------

if __name__=='__main__':
    _debug()
    
'''
    return template

# language = python
# category = config
# author = Mazhugin Aleksey
def new_config(fields):
    """
    Config template.
    """
    template='''
#--------------------------------------------------------------------
# Filname: @FileName@
# Author: @Author@
# Created: @Date@
# ID: $Id'''+''': $
# URL: $URL'''+''': $
# Copyright: @Copyright@
# License: @License@
#--------------------------------------------------------------------

# Configuration file for @ConfigFor@

[DEFAULTS]
# Default settings.

[Section1]
Option1 = val1

'''
    return template

# language = python
# category = config
# author = Mazhugin Aleksey
def new_xlogging(fields):
    """
    XLogging config template for application/package.
    
    app - You top level application (package) name same as in import..
    """
    template='''
#--------------------------------------------------------------------
# Filname: @FileName@
# Author: @Author@
# Created: @Date@
# ID: $Id'''+''': $
# URL: $URL'''+''': $
# Copyright: @Copyright@
# License: @License@
#--------------------------------------------------------------------

# Configuration file for @ConfigFor@

[DEFAULTS]
# Default settings.

[manager]
#disable=WARNING

[loggers]
keys=root, app

[handlers]
keys=dbg, trace, log, null

[formatters]
keys=dbg, trace, log

[filters]
keys=dbg, trace, app, null

[logger_root]
level=WARNING
#handlers=hand01
#filters=
#actions=act01, act02
#act01=clear, handler
#act02=remove, filter, filt99
#disabled=0
#attributes=attr01
#attr01= name, A.B.C

[logger_app]
level=DBGTRACE
handlers=dbg, trace, log
propagate=0
qualname=@app@
#disabled=0
#filters=
#actions=act01
#act01=clear,handler
#disabled=0
#attributes=attr01
#attr01= name, A.B.C

[handler_dbg]
# FileHandler for DBGTrace and DEBUG
class=FileHandler 
level=DBGTRACE
formatter=dbg
args=(__import__('os').path.join(__import__(@app@).dir_logs, '@app@_dbg.log'), 'w')
filters=dbg, app
#actions=act01
#act01=add, filter, filt01
#attributes=attr01
#attr01= attrname, A.B.C

[handler_trace]
# FileHandler for TRACE
class=__import__('logging.handlers').handlers.RotatingFileHandler
level=TRACE
formatter=trace
args=(__import__('os').path.join(__import__(@app@).dir_logs, '@app@_trace.log'), 'w', 1000000, 2)
filters=trace, app
#actions=act01
#act01=add, filter, filt01
#attributes=attr01
#attr01= attrname, A.B.C

[handler_log]
# FileHandler for Release logging
class=__import__('logging.handlers').handlers.RotatingFileHandler
level=WARNING
formatter=log
args=(__import__('os').path.join(__import__(@app@).dir_logs, '@app@.log'), 'w', 100000, 2)
filters=app
#actions=act01
#act01=add, filter, filt01
#attributes=attr01
#attr01= attrname, A.B.C

[handler_null]
# No logging
class=NullHandler
level=NOTSET

[filter_dbg]
# RangeFilter
class=RangeFilter
args=(DBGTRACE, DEBUG)
#attributes=attr01
#attr01= name, A.B.C

[filter_trace]
# RangeFilter
class=RangeFilter
args=(TRACE, TRACE)
#attributes=attr01
#attr01= name, A.B.C

[filter_null]
# RangeFilter, disable all.
class=RangeFilter
args=(CRITICAL, NOTSET)
#attributes=attr01
#attr01= name, A.B.C

[filter_app]
# Filter for available XPyLIB loggers only.
class=Filter
args=('xpylib',)
#attributes=attr01
#attr01= name, A.B.C

[formatter_dbg]
format=%(message)s
datefmt=%Y-%m-%d %H:%M:%S
class=IndentFormatter
#args=()
#attributes=attr01
#attr01= name, A.B.C

[formatter_trace]
format=%(asctime)s %(levelname)s:%(name)s:%(message)s
datefmt=%Y-%m-%d %H:%M:%S
#class=IndentFormatter
#args=()

[formatter_log]
format=%(asctime)s %(levelname)s:%(name)s:%(message)s
datefmt=%Y-%m-%d %H:%M:%S
#class=Formatter
#args=()
#attributes=attr01
#attr01= name, A.B.C

'''
    return template