#!/usr/bin/env python
# -*- coding: utf-8 -*-
#--------------------------------------------------------------------
# Author: Mazhugin Aleksey
# Created: 2007/12/14
# ID: $Id: $
# URL: $URL: $
# Copyright: Copyright (c) 2007, Mazhugin Aleksey
# License: BSD
#--------------------------------------------------------------------

"""
wxPython code templates for python.
"""

# language = python
# category = wx
# author = Mazhugin Aleksey
def tpl_wx_simple_dlg_app(fields):
    """
    Simple wxPython dialog application template.
    """
    template= '''
try:
    app = wx.PySimpleApp()
    dlg = MyDialog(None, -1, "")
    dlg.ShowModal()
    #app.SetTopWindow(dlg)
    #dlg.Show()
    #app.MainLoop() 
finally:
    dlg.Destroy()
    pass
    '''
    return template

# language = python
# category = wx
# author = Mazhugin Aleksey
def tpl_wx_color_dlg(fields):
    """
    wxPython color dialog.
    """
    template= '''
data = wx.ColourData()
data.SetChooseFull(True)
dlg = wx.ColourDialog(self, data)
try:
    if dlg.ShowModal() == wx.ID_OK:
        data = dlg.GetColourData()
        # Your code
finally:
    dlg.Destroy()
    '''
    return template

# language = python
# category = wx
# author = Mazhugin Aleksey
def tpl_wx_font_dlg(fields):
    """
    wxPython font dialog.
    """
    template= '''
data = wx.FontData()
dlg = wx.FontDialog(self, data)
try:
    if dlg.ShowModal() == wx.ID_OK:
        data = dlg.GetFontData()
        font = data.GetChosenFont()
        # Your code
finally:
    dlg.Destroy()
    '''
    return template

# language = python
# category = wx
# author = Mazhugin Aleksey
def tpl_wx_print_dlg(fields):
    """
    wxPython print dialog.
    """
    template= '''
data = wx.PrintDialogData()
data.EnablePrintToFile(True)
data.EnablePageNumbers(True)
data.EnableSelection(True)
dlg = wx.PrintDialog(self, data)
try:
    if dlg.ShowModal() == wx.ID_OK:
        # Your code
finally:
    dlg.Destroy()
    '''
    return template

# language = python
# category = wx
# author = Mazhugin Aleksey
def tpl_wx_page_setup_dlg(fields):
    """
    wxPython page setup dialog.
    """
    template= '''
data = wx.PageSetupDialogData()
data.SetMarginTopLeft(wx.Point(50,50))
data.SetMarginBottomRight(wx.Point(50,50))
dlg = wx.PageSetupDialog(self, data)
try:
    if dlg.ShowModal() == wx.ID_OK:
        data = dlg.GetPageSetupData()
        # Your code
finally:
    dlg.Destroy()
    '''
    return template

# language = python
# category = wx
# author = Mazhugin Aleksey
def tpl_wx_dir_dlg(fields):
    """
    wxPython directory dialog.
    """
    template= '''
dlg = wx.DirDialog(self)
try:
    if dlg.ShowModal() == wx.ID_OK:
        path = dlg.GetPath()
        # Your code
finally:
    dlg.Destroy()
    '''
    return template

# language = python
# category = wx
# author = Mazhugin Aleksey
def tpl_wx_file_dlg(fields):
    """
    wxPython file dialog.
    """
    template= '''
dlg = wx.FileDialog(self, 'Choose a file', '.', '', '*.*', wx.OPEN)
try:
    if dlg.ShowModal() == wx.ID_OK:
        filename = dlg.GetPath()
        # Your code
finally:
    dlg.Destroy()
    '''
    return template

# language = python
# category = wx
# author = Mazhugin Aleksey
def tpl_wx_single_choice_dlg(fields):
    """
    wxPython single choice dialog.
    """
    template= '''
dlg = wx.SingleChoiceDialog(self, 'Question', 'Caption', [])
try:
    if dlg.ShowModal() == wx.ID_OK:
        selected = dlg.GetStringSelection()
        # Your code
finally:
    dlg.Destroy()
    '''
    return template

# language = python
# category = wx
# author = Mazhugin Aleksey
def tpl_wx_text_entry_dlg(fields):
    """
    wxPython text entry dialog.
    """
    template= '''
dlg = wx.TextEntryDialog(self, 'Question', 'Caption', 'Default answer')
try:
    if dlg.ShowModal() == wx.ID_OK:
        result = dlg.GetValue()
        # Your code
finally:
    dlg.Destroy()
    '''
    return template

# language = python
# category = wx
# author = Mazhugin Aleksey
def tpl_wx_message_dlg(fields):
    """
    wxPython message dialog.
    """
    template= '''
dlg = wx.MessageDialog(self, 'Message', 'Caption', wx.OK | wx.ICON_INFORMATION)
try:
    result = dlg.ShowModal()
finally:
    dlg.Destroy()
    '''
    return template

# language = python
# category = wx
# author = Mazhugin Aleksey
def tpl_wx_find_replace_dlg(fields):
    """
    wxPython find/replace dialog.
    """
    template= '''
data = wx.FindReplaceData()
dlg = wx.FindReplaceDialog(self, data, 'Find Dialog')
dlg.Show(True)
    '''
    return template

# language = python
# category = wx
# author = Mazhugin Aleksey
def tpl_wx_multichoice_dlg(fields):
    """
    wxPython multichoice dialog.
    """
    template= '''
dlg = wx.MultiChoiceDialog(self, 'Message', 'Caption', [], wx.CHOICEDLG_STYLE)
try:
    result = dlg.GetSelections()
finally:
    dlg.Destroy()
    '''
    return template

# language = python
# category = wx
# author = Mazhugin Aleksey
def tpl_wx_busy_cursur_dlg(fields):
    """
    wxPython busy cursor dialog.
    """
    template= '''
wx.BeginBusyCursor()
try:
    # Your code
finally:
    wx.EndBusyCursor()
    '''
    return template

# language = python
# category = wx
# author = Mazhugin Aleksey
def tpl_wx_locale_dlg(fields):
    """
    wxPython locale.
    """
    template= '''
self.locale = wx.Locale(wx.LANGUAGE_DEFAULT)
wx.Locale.AddCatalogLookupPathPrefix('locale')
self.locale.AddCatalog('mycatalog')
    ''' 
    return template

# language = python
# category = wx
# author = Mazhugin Aleksey
def tpl_wx_about_box_dlg(fields):
    """
    wxPython about box dialog.
    """
    template= '''
info = wx.AboutDialogInfo()
info.Name = '@Name@'
info.Version = '@Version@'
info.Copyright = '@Copyright@'
info.Description = '@Description@'
wx.AboutBox(info)
    '''
    return template

